﻿using WisejWebApplication;
using System;
using System.Collections.Generic;
using System.Reflection;
using System.Threading;
using System.Threading.Tasks;
using Wisej.Web;

namespace WisejWebApplication
{
    public partial class Window2 : Form
    {
        public Window2()
        {
            InitializeComponent();
        }

        private void bindingSource1_CurrentChanged(object sender, EventArgs e)
        {
            if(bindingSource1.Current != null)
            {
                Obj obj = bindingSource1.Current as Obj;
                textBox2.Text = obj.Text1;
                textBox3.Text = obj.Text2;
                textBox1.Text = SlowOperation();
            }
        }

        private void bindingSource1_ListChanged(object sender, System.ComponentModel.ListChangedEventArgs e)
        {

        }

        private void Window2_Load(object sender, EventArgs e)
        {
            //customTextBoxInteger.Validator = TextBoxValidation.IntegerValidator;
            //customTextBoxEmail.Validator = TextBoxValidation.EmailValidator;
            ////decimalTextBox1.Format = new System.Drawing.Point(9, 3);
            ////decimalTextBox1.Value = 90.125m;
            //dataGridView1.VirtualMode = false;
            //bindingSource1.DataSource = new DataBindingList<List<Obj>, Obj>(Obj.GenererateData(4000));
        }
        private string SlowOperation()
        {
            Thread.Sleep(200);
            return DateTime.Now.ToString();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
            this.Close();
           //MessageBox.Show(customDateTime2.Value.ToString());
        }

        private void button2_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            this.Close();
        }
    }

    public static class ReflectionHelper
    {
        private static PropertyInfo GetPropertyInfo(Type type, string propertyName)
        {
            PropertyInfo propInfo = null;
            do
            {
                propInfo = type.GetProperty(propertyName,
                       BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic);
                type = type.BaseType;
            }
            while (propInfo == null && type != null);
            return propInfo;
        }

        public static object GetPropertyValue(this object obj, string propertyName)
        {
            if (obj == null)
                throw new ArgumentNullException("obj");
            Type objType = obj.GetType();
            PropertyInfo propInfo = GetPropertyInfo(objType, propertyName);
            if (propInfo == null)
                throw new ArgumentOutOfRangeException("propertyName",
                  string.Format("Couldn't find property {0} in type {1}", propertyName, objType.FullName));
            return propInfo.GetValue(obj, null);
        }

        public static void SetPropertyValue(this object obj, string propertyName, object val)
        {
            if (obj == null)
                throw new ArgumentNullException("obj");
            Type objType = obj.GetType();
            PropertyInfo propInfo = GetPropertyInfo(objType, propertyName);
            if (propInfo == null)
                throw new ArgumentOutOfRangeException("propertyName",
                  string.Format("Couldn't find property {0} in type {1}", propertyName, objType.FullName));
            propInfo.SetValue(obj, val, null);
        }
    }
}
